//////////////////////////////////////////////////////////////////////
// Simple consol print demo
// -- dovoto
//////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <nds.h>
#include <libfb\libcommon.h>

#include "Sound9.h"
#include "happy1.h"
#include "happy2.h"
#include "sad1.h"
#include "font_kartika_14.h"

	// 256KB to load MOD files into. Actual size necessary is the size 
	// of your largest MOD file (probably less than 256KB).
#define SND_MEM_POOL_SIZE	256*1024

	// Out in the middle of main RAM. Not generally safe, but I can't 
	// figure out how to keep a static array from bloating the ROM :)
u32 *sndMemPool;

extern u8 *happy[];

int main(void)
{
	int x = 260;
	int a = 1;
	
	sndMemPool = (u32 *)malloc(SND_MEM_POOL_SIZE);
	
    powerON(POWER_ALL_2D);
	
	SndInit9 ();
	SndSetMemPool(sndMemPool, SND_MEM_POOL_SIZE);
	
    irqSet(IRQ_VBLANK, 0);
	irqEnable(IRQ_VBLANK);	
			
	fb_init();	
	bg_init();
	setFont((uint16 **)font_kartika_14);
	
	//lcdSwap();
	
	bg_setBG((uint16 *)happy1);
	fb_setBG((uint16 *)happy2);
	swiWaitForVBlank();
	fb_swapBuffers();
	bg_swapBuffers();	
		
	SndPlayMOD(happy);
	bg_disableClipping();
	fb_disableClipping();
	
	while(a != 3) {
		setColor(0xFFFF);
		bg_dispString(x,10, "HappyCat demo by DragonMinded to show off libfb.");
		
		setColor(RGB15(31,0,0));
		fb_dispString(x,150, "                                                                                           Enjoy your happy!");
		setColor(RGB15(0,31,31));
		fb_dispString(x,10, "                                                                                                                                            Sorry guys :(");
		
		x-=a;
		
		if( x == -295 ) {
			a = 2;
		}	
		
		if( x < -970 )
			a = 3;
		
		swiWaitForVBlank();		
		//if(x > -680)
			bg_swapBuffers();
		//else
			fb_swapBuffers();
	}
	
	fb_eraseBG();
	bg_setBG((uint16 *)sad1);
	setColor(0xFFFF);
	fb_enableClipping();
	
	swiWaitForVBlank();			
	fb_swapBuffers();
	bg_swapBuffers();	
	fb_dispString(10,90, "HappyCat has run out of happy.");
	
	swiWaitForVBlank();		
	fb_swapBuffers();
	bg_swapBuffers();
	
	while(1) {
		swiWaitForVBlank();
	}
}
